﻿using Infragistics.Themes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace WpfApplication20.Resources
{
    /// <summary>
    /// A helper class ment to make it easy to reference xaml resource dictionaries haused in a theme assembly.
    /// </summary>
    public class CustomResourceDictionary : ResourceDictionary
    {
        Type _typeFromHostingAssembly = null;
        string _location = null;
        bool _targetRDLoaded = false;

        public Type TypeFromHostingAssembly 
        {
            get { return this._typeFromHostingAssembly; }
            set 
            {
                this._typeFromHostingAssembly = value;
                this.LoadTargetResourceDictionary();
            }
        }
        public string Location
        {
            get { return this._location; }
            set
            {
                this._location = value;
                this.LoadTargetResourceDictionary();
            }
        }

        private bool LoadTargetResourceDictionary()
        {
            if (this._targetRDLoaded)
                return true;

            if (this.TypeFromHostingAssembly == null || string.IsNullOrEmpty(this.Location))
                return false;

            var source = ThemeBase.BuildLocationString(this.TypeFromHostingAssembly.Assembly.FullName, this.Location);

            this.MergedDictionaries.Add(new ResourceDictionary() { Source = new Uri(source) });

            return this._targetRDLoaded = true;
        }
    }
}
